
// You have to format the track before you can write to it.
// This program formats a floppy to 1.49 megabytes with the extra track
// just change byte 19 of BYTE sector45_0[512] below to 64 from 136
// and it will appear to be 1.44 megabytes.  But the disk and track
// can still be read and copied if one knows where to look.
// Diskcopy is only going to miss your password not the rest of the disk.
// Declare your password byte sector as below
// BYTE password_sector[512] = {0,'m','y',0,'p','a','s','s','w','o','r','d',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
// and add the following line before   // UNLOCK DRIVE in main
// WriteFAT(2880/*your password can be in sectors numbered from 2880 to 2951*/,reinterpret_cast<LPBYTE>(&password_sector));
// i:\borland\bcc55\bin\BCC32 -c -I"i:\borland\bcc55\include" -L"i:\borland\bcc55\lib" z.cpp
// i:\borland\bcc55\bin\ILINK32 -ap -Tpe -S:1000 -m -L"i:\borland\bcc55\lib" i:\borland\bcc55\lib\c0x32.obj "z.obj",roak , , i:\borland\bcc55\lib\import32.lib i:\borland\bcc55\lib\cw32.lib
// To read the password sector read the boot sector with #define VWIN32_DIOC_DOS_INT25 2
// instead of #define VWIN32_DIOC_DOS_INT26 3 and change byte 19 of the boot
// sector from 64 to 136.  Windows will recognize the track and next read your sector. 

#include <windows.h>
#include <winbase.h>
#include <winioctl.h>
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <fstream.h>
#include <time.h>

#define VWIN32_DIOC_DOS_IOCTL	1	// int 21h for lock and unlock
#define VWIN32_DIOC_DOS_INT26 	3	// int 26h for write
#define VWIN32_DIOC_DOS_INT13	4	// int 13h for format

typedef struct DIOCRegs {
    DWORD   reg_EBX;   
    DWORD   reg_EDX;  
    DWORD   reg_ECX;  
    DWORD   reg_EAX;   
    DWORD   reg_EDI;  
    DWORD   reg_ESI;   
    DWORD   reg_Flags; 
} DIOC_REGISTERS;


BOOL LockFloppy() {

	DIOC_REGISTERS roakregs = {0};
	BOOL fResult;
	DWORD cb;
	roakregs.reg_EAX = 0x440D;		//function call
	roakregs.reg_EBX = 0x0001;		//drive A = 01h
	roakregs.reg_ECX = 0x084A;		//lock drive
		
	HANDLE hDev = CreateFile("\\\\.\\vwin32", 
		0, 
		0, 
		0, 
		0,
		FILE_FLAG_DELETE_ON_CLOSE, 
		0);

	fResult = DeviceIoControl (hDev,
		VWIN32_DIOC_DOS_IOCTL,
		&roakregs,
		sizeof(roakregs),
		&roakregs,
		sizeof(roakregs),
		&cb,
		0);

	CloseHandle(hDev);

	return fResult;
}


BOOL UnlockFloppy() {

	DIOC_REGISTERS roakregs = {0};
	BOOL fResult;
	DWORD cb;
	roakregs.reg_EAX = 0x440D;		//function call
	roakregs.reg_EBX = 0x0001;		//drive A = 01h
	roakregs.reg_ECX = 0x086A;		//unlock drive
		
	HANDLE hDev = CreateFile("\\\\.\\vwin32", 
		0, 
		0, 
		0, 
		0,
		FILE_FLAG_DELETE_ON_CLOSE, 
		0);

	fResult = DeviceIoControl (hDev,
		VWIN32_DIOC_DOS_IOCTL,
		&roakregs,
		sizeof(roakregs),
		&roakregs,
		sizeof(roakregs),
		&cb,
		0);

	CloseHandle(hDev);

	return fResult;
}


BOOL FormatRoutine (int side, int track) {

// DECLARE VARIABLES
	DIOC_REGISTERS roakregs = {0};
	BOOL fResult;
	DWORD cb;
	BYTE t = (BYTE)track;
	BYTE s = (BYTE)side;
	BYTE formatbuffer[72] = {t,s,1,2,
							t,s,2,2,
							t,s,3,2,
							t,s,4,2,
 							t,s,5,2,
							t,s,6,2,
							t,s,7,2,
 							t,s,8,2,
							t,s,9,2,
							t,s,10,2,
							t,s,11,2,
 							t,s,12,2,
							t,s,13,2,
							t,s,14,2,
 							t,s,15,2,
							t,s,16,2,
							t,s,17,2,
							t,s,18,2};

/*// THIS FORMAT BUFFER ALSO WORKS	
	BYTE *pbuf;
	BYTE formatbuffer[72];
	pbuf = formatbuffer;
	pbuf[0] = t; pbuf[1] = s; pbuf[2] = 1; pbuf[3] = 2;
	pbuf[4] = t; pbuf[5] = s; pbuf[6] = 2; pbuf[7] = 2;
	pbuf[8] = t; pbuf[9] = s; pbuf[10] = 3; pbuf[11] = 2;
	pbuf[12] = t; pbuf[13] = s; pbuf[14] = 4; pbuf[15] = 2;
	pbuf[16] = t; pbuf[17] = s; pbuf[18] = 5; pbuf[19] = 2;
	pbuf[20] = t; pbuf[21] = s; pbuf[22] = 6; pbuf[23] = 2;
	pbuf[24] = t; pbuf[25] = s; pbuf[26] = 7; pbuf[27] = 2;
	pbuf[28] = t; pbuf[29] = s; pbuf[30] = 8; pbuf[31] = 2;
	pbuf[32] = t; pbuf[33] = s; pbuf[34] = 9; pbuf[35] = 2;
	pbuf[36] = t; pbuf[37] = s; pbuf[38] = 10; pbuf[39] = 2;
	pbuf[40] = t; pbuf[41] = s; pbuf[42] = 11; pbuf[43] = 2;
	pbuf[44] = t; pbuf[45] = s; pbuf[46] = 12; pbuf[47] = 2;
	pbuf[48] = t; pbuf[49] = s; pbuf[50] = 13; pbuf[51] = 2;
	pbuf[52] = t; pbuf[53] = s; pbuf[54] = 14; pbuf[55] = 2;
	pbuf[56] = t; pbuf[57] = s; pbuf[58] = 15; pbuf[59] = 2;
	pbuf[60] = t; pbuf[61] = s; pbuf[62] = 16; pbuf[63] = 2;
	pbuf[64] = t; pbuf[65] = s; pbuf[66] = 17; pbuf[67] = 2;
	pbuf[68] = t; pbuf[69] = s; pbuf[70] = 18; pbuf[71] = 2;*/

// GET DEVICE HANDLE
	HANDLE hDev = CreateFile("\\\\.\\vwin32", 
		0, 
		0, 
		NULL, 
		0,
		FILE_FLAG_DELETE_ON_CLOSE, NULL);

// AH = 05h FORMAT FUNCTION; AL = SECTORS PER TRACK
	roakregs.reg_EAX = 256 * 5 + (18 & 0xff);
// ES:BX = SEGMET OFFSET OF FORMAT BUFFER
	roakregs.reg_EBX = (DWORD)&formatbuffer;
	roakregs.reg_ESI = (DWORD)&formatbuffer;
// CH = TRACK; CL = 0
	roakregs.reg_ECX = 256 * (track & 0xff);				
// DH = HEAD; DL = DRIVE A:
	roakregs.reg_EDX = 256 * (side & 0x0ff) + (0 & 0xff); 
// CARRY FLAG IS SET ASSUME ERROR
	roakregs.reg_Flags = 0x0001;

// CALL INTERRUPT 13h
	fResult = DeviceIoControl(hDev,
		VWIN32_DIOC_DOS_INT13,
		&roakregs, 
		sizeof(roakregs),
		&roakregs, 
		sizeof(roakregs),
		&cb, 
		0);

// CLOSE HANDLE
	CloseHandle(hDev);

// DISPLAY PROGRESS
// USE stderr, stdout, or stdin  -- important to have space between last type and \r
	fprintf (stderr, "     Formatting side %d of track %d, where error code = %d. \a \a \a \r", side, track, roakregs.reg_EAX >> 8 );

// RETURN
	if (!fResult || (roakregs.reg_Flags & 0x0001)) return FALSE;
	else return TRUE;
}


BOOL WriteFAT(int wsector, LPBYTE LPB) {

// DECLARE VARIABLES
	DIOC_REGISTERS roakregs = {0};
	BOOL fResult;
	DWORD cb;
// DRIVE A:
	roakregs.reg_EAX = 0x0000;			
// DS:BX segment:offset of source buffer
	roakregs.reg_EBX = (DWORD)LPB;
// NUMBER OF SECTORS TO WRITE
	roakregs.reg_ECX = 0x0001;	
// FIRST SECTOR TO WRITE IS ZERO BASED
	roakregs.reg_EDX = 256 * (0 & 0xff) + (wsector & 0xff);	

// GET DEVICE HANDLE
	HANDLE hDev = CreateFile("\\\\.\\vwin32", 
		0, 
		0, 
		NULL, 
		0,
		FILE_FLAG_DELETE_ON_CLOSE, NULL);

// CALL INTERRUPT 26h
	fResult = DeviceIoControl(hDev,
		VWIN32_DIOC_DOS_INT26,
		&roakregs, 
		sizeof(roakregs),
		&roakregs, 
		sizeof(roakregs),
		&cb, 
		0);

// FIX ANOMALY
	__asm pop CX
	__asm pop DX

// DISPLAY PROGRESS
	fprintf (stderr, "     Writing sector %d, where error code = %d. \r", wsector, roakregs.reg_EAX >> 8 );

// CLOSE HANDLE
	CloseHandle(hDev);

//RETURN
	return fResult;

}


void main () {

//DECLARE SOME VARIABLES 
	int wsector;
	int track, side;
	char cy = 'N';

// GET TIME ONLY IF YOU ARE GOING TO DISPLAY TIME DATE & SERIAL NUMBERS CORRECTLY
	time_t dayto = time(0);
	cout << "\n\n     The date and time of your format will be: " << asctime(localtime(&dayto));

//H  H  H  H  H  M  M M M M M S S S S S
//15 14 13 12 11 10 9 8 7 6 5 4 3 2 1 0	  bit
//Y  Y  Y  Y  Y  M  M M M M M D D D D D
	struct tm* ltim = localtime(&dayto);
	BYTE btsec42 = 0, btsec41 = 0, btsec40 = 0, btsec39 = 0, rtsec25 = 0, rtsec24 = 0, rtsec23 = 0, rtsec22 = 0;
	WORD SNL = 0, SNH = 0, DATE = 0, TIME = 0;
	int year = ltim->tm_year - 80;	//1900 based
	int month = ltim->tm_mon + 1;	//zero based
	int day = ltim->tm_mday;
	int hour = ltim->tm_hour;
	int minute = ltim->tm_min;	
	int second = ltim->tm_sec;	

// DATE
	__asm{
// year
		mov AX, WORD PTR [year]
		shl AX, 1
		mov AH, AL
		mov AL, 0
		mov DATE, AX
// month
		mov AL, BYTE PTR [month]
		mov AH, 0
		shl AX, 1
		shl AX, 1	
		shl AX, 1	
		shl AX, 1
		shl AX, 1
		add DATE, AX
		mov AX, DATE
		mov rtsec25, AH
// day
		mov AH, 0
		mov AL, BYTE PTR [day]
		add DATE, AX
		mov AX, DATE
		mov rtsec24, AL
	}

// TIME
	_asm{
// hour
		mov AL, BYTE PTR [hour]
		shl AL, 1
		shl AL, 1
		shl AL, 1
		mov AH, AL
		mov AL, 0
		mov TIME, AX
// minute
		mov AH, BYTE PTR [minute]
		mov AL, 0
		shr AX, 1
		shr AX, 1
		shr AX, 1
		add TIME, AX
		mov AX, TIME
		mov rtsec23, AH
// second
		mov AH, 0
		mov AL, BYTE PTR [second]
		add TIME, AX
		mov AX, TIME
		mov rtsec22, AL
	}


// SERIAL NUMBER
// low order left four digits for month day and seconds
// month & day
// plus seconds & hundredths
	__asm{
		mov AH, BYTE PTR [month]
		mov AL, BYTE PTR [day]
		mov SNL, AX
		mov AH, BYTE PTR [second]
		mov AL, 0//hundredth seconds
		add SNL, AX
		mov AX, SNL
		mov btsec42, AH
		mov btsec41, AL
	}

// high order right 4 digits of serial number for year hour & minute
// hours & minutes
// plus year
	__asm{
		mov AH, BYTE PTR [hour]
		mov AL, BYTE PTR [minute]
		mov SNH, AX
		mov AX, WORD PTR [year]
		add SNH, AX
		mov AX, SNH
		mov btsec40, AH
		mov btsec39, AL
	}

// SECTOR BUFFERS
	BYTE sector45_0[512] = {/*jump*/235,60,144,/*OEM*/40,123,58,105,90,73,72,67,0,/* 2 * 256 = 512 bytes per sector*/2,/*sectors per cluster*/1,/*# sectors before FAT*/1,0,/*FAT count*/2,/*max # entries in root dir*/224,0,/*total sectors = 64+(256*11) = 2880 but used 136+(2565*11) = 2952 sectors instead of 64 for 1.49 mb disk*/136,11,/*media*/240,/*FAT size*/9,0,/*sectors per track*/18,0,/*head count*/2,0,/*hidden sectors*/0,0,0,0,/*huge sectors*/0,0,0,0,/*drive number*/0,/*reserved*/0,/*boot sign = )*/41,/*serial number FEED-BABE = BE BA ED FE = 190,186,237,254,*/btsec39,btsec40,btsec41,btsec42,/*volume label RK NOG___*/82,153,142,75,32,78,79,71,32,32,32,/*FAT12*/70,65,84,49,50,32,32,32,51,201,142,209,188,252,123,22,7,189,120,0,197,118,0,30,86,22,85,191,34,5,137,126,0,137,78,2,177,11,252,243,164,6,31,189,0,124,198,69,254,15,56,78,36,125,32,139,193,153,232,126,1,131,235,58,102,161,28,124,102,59,7,138,87,252,117,6,128,202,2,136,86,2,128,195,16,115,237,51,201,254,6,216,125,138,70,16,152,247,102,22,3,70,28,19,86,30,3,70,14,19,209,139,118,17,96,137,70,252,137,86,254,184,32,0,247,230,139,94,11,3,195,72,247,243,1,70,252,17,78,254,97,191,0,7,232,40,1,114,62,56,45,116,23,96,177,11,190,216,125,243,166,97,116,61,78,116,9,131,199,32,59,251,114,231,235,221,254,14,216,125,123,167,190,127,125,172,152,3,240,172,152,64,116,12,72,116,19,180,14,187,7,0,205,16,235,239,190,130,125,235,230,190,128,125,235,225,205,22,94,31,102,143,4,205,25,190,129,125,139,125,26,141,69,254,138,78,13,247,225,3,70,252,19,86,254,177,4,232,194,0,114,215,234,0,2,
		112,0,82,80,6,83,106,1,106,16,145,139,70,24,162,38,5,150,146,51,210,247,246,145,247,246,66,135,202,247,118,26,138,242,138,232,192,204,2,10,204,184,1,2,128,126,2,14,117,4,180,66,139,244,138,86,36,205,19,97,97,114,10,64,117,1,66,3,94,11,73,117,119,195,3,24,1,39,13,10,73,110,118,97,108,105,100,32,115,121,115,116,101,109,32,100,105,115,107,255,13,10,68,105,115,107,32,73,47,79,32,101,114,114,111,114,255,13,10,82,101,112,108,97,99,101,32,116,104,101,32,100,105,115,107,44,32,97,110,100,32,116,104,101,110,32,112,114,101,115,115,32,97,110,121,32,107,101,121,13,10,0,0,73,79,32,32,32,32,32,32,83,89,83,77,83,68,79,83,32,32,32,83,89,83,127,1,0,65,187,0,7,96,102,106,0,233,59,255,0,0,85,170};
	BYTE sector45_1[512] = {240,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
	BYTE sector45_10[512] = {240,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
	BYTE sector45_19[512] = {/*root dir RK NOG*/82,153,142,75,32,78,79,71,/*file extension*/32,32,32,/*file attribute*/40,/*reserved*/0,0,0,0,0,0,0,0,0,0,/*time*/rtsec22,rtsec23,/*date*/rtsec24,rtsec25/* or to just display year (BYTE)byteye*/,/*cluster number*/0,0,/*file size*/0,0,0,0,/*end root dir*/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
	BYTE sectorallothers[512] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

// QUESTION
	cout << "\n\n     Make sure you have a 1.44 megabyte floppy disk in drive A.\n     This is a high level program for the Windows environment\n     and an unusually formatted disk will not format well\n     with this software.  Enter Y or y if you want to format\n     the floppy disk in drive A: to 1.49 megabytes.  Warning, all\n     data on the disk will be lost.  Take the disk out of the\n     drive and reinsert the floppy for Windows to take notice\n     of the new format.\n\n     ";
	cin >> cy;
	if ( cy != 'Y' && cy != 'y' ) {cout << "\n\n     You chose not to format A:!\n\n     "; goto skip;}	

// LOCK DRIVE
	if(LockFloppy() == TRUE)printf("\n     Lock succeeded!\n\n");
	else printf("\n\n     Lock failed!\n\n");

// FORMAT FLOPPY
	for (track = 0; track < 82; track++)
	{
	for (side = 0; side <= 1; side++)
	{
	FormatRoutine (side,track);
	}
	}

// NEW LINE
	printf("\n\n     *****     \n\n");

// WRITE FAT SECTORS
	WriteFAT(0,reinterpret_cast<LPBYTE>(&sector45_0));
	WriteFAT(1,reinterpret_cast<LPBYTE>(&sector45_1));
	WriteFAT(2,reinterpret_cast<LPBYTE>(&sectorallothers));
	WriteFAT(3,reinterpret_cast<LPBYTE>(&sectorallothers));
	WriteFAT(4,reinterpret_cast<LPBYTE>(&sectorallothers));
	WriteFAT(5,reinterpret_cast<LPBYTE>(&sectorallothers));
	WriteFAT(6,reinterpret_cast<LPBYTE>(&sectorallothers));
	WriteFAT(7,reinterpret_cast<LPBYTE>(&sectorallothers));
	WriteFAT(8,reinterpret_cast<LPBYTE>(&sectorallothers));
	WriteFAT(9,reinterpret_cast<LPBYTE>(&sectorallothers));
	WriteFAT(10,reinterpret_cast<LPBYTE>(&sector45_10));
	WriteFAT(11,reinterpret_cast<LPBYTE>(&sectorallothers));
	WriteFAT(12,reinterpret_cast<LPBYTE>(&sectorallothers));
	WriteFAT(13,reinterpret_cast<LPBYTE>(&sectorallothers));
	WriteFAT(14,reinterpret_cast<LPBYTE>(&sectorallothers));
	WriteFAT(15,reinterpret_cast<LPBYTE>(&sectorallothers));
	WriteFAT(16,reinterpret_cast<LPBYTE>(&sectorallothers));
	WriteFAT(17,reinterpret_cast<LPBYTE>(&sectorallothers));
	WriteFAT(18,reinterpret_cast<LPBYTE>(&sectorallothers));
	WriteFAT(19,reinterpret_cast<LPBYTE>(&sector45_19));
	WriteFAT(20,reinterpret_cast<LPBYTE>(&sectorallothers));
	WriteFAT(21,reinterpret_cast<LPBYTE>(&sectorallothers));
	WriteFAT(22,reinterpret_cast<LPBYTE>(&sectorallothers));	
	WriteFAT(23,reinterpret_cast<LPBYTE>(&sectorallothers));
	WriteFAT(24,reinterpret_cast<LPBYTE>(&sectorallothers));
	WriteFAT(25,reinterpret_cast<LPBYTE>(&sectorallothers));
	WriteFAT(26,reinterpret_cast<LPBYTE>(&sectorallothers));
	WriteFAT(27,reinterpret_cast<LPBYTE>(&sectorallothers));
	WriteFAT(28,reinterpret_cast<LPBYTE>(&sectorallothers));
	WriteFAT(29,reinterpret_cast<LPBYTE>(&sectorallothers));
	WriteFAT(30,reinterpret_cast<LPBYTE>(&sectorallothers));
	WriteFAT(32,reinterpret_cast<LPBYTE>(&sectorallothers));
	WriteFAT(32,reinterpret_cast<LPBYTE>(&sectorallothers));
	WriteFAT(33,reinterpret_cast<LPBYTE>(&sectorallothers));
	WriteFAT(34,reinterpret_cast<LPBYTE>(&sectorallothers));
	WriteFAT(35,reinterpret_cast<LPBYTE>(&sectorallothers));

// UNLOCK DRIVE
	if(UnlockFloppy() == TRUE)printf("\n\n     Unlock succeeded!\n\n");
	else printf("\n\n     Unlock failed!\n\n");

skip:
// DISPLAY COPYRIGHT
	printf ("\n\n     Freehafer's Floppy Format Program Is Terminated!\n\n     (c)2002 INNIEA PUBLISHING COMPANY!\n\n     (r)R%c%cK NOG!\n\n     ", (char)153, (char)142);
    getchar();
}
